import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PlayerTank here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayerTank  extends Tank
{
    /**
     * the turret associated with this player tank
     */
    private Turret turret;
    
    private boolean wishesToFire;
    private static final int FIRING_DELAY = 100;
    private int curFireCount = 0;
    
    /**
     * constructor - initialise the associated tank turret
     */
    public PlayerTank() 
    {
        turret = new Turret(this);
    }
        
    /**
     * turn the tank & the turret
     */
    @Override
    public void turn(int angle)
    {
        super.turn(angle);
        turret.turn(angle);
    }

    /**
     * turn the turret of the tank
     */
    public void turnTurret(int angle) {
        turret.turn(angle);
        System.out.println(turret.getRotation());
    }
    
    /**
     * Act - do whatever the PlayerTank wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        processKeys();
        processFiring();
    }       
    
    public void processKeys() {
        if (Greenfoot.isKeyDown("up")) {
            this.move(-2);
        }
        if (Greenfoot.isKeyDown("down")) {
           this.move(+2);
        }
        if (Greenfoot.isKeyDown("left")) {
            this.turn(-2);
        }
        if (Greenfoot.isKeyDown("right")) {
           this.turn(+2);
        }
        if (Greenfoot.isKeyDown("a")) {
            turret.turn(-2);
        }
        if (Greenfoot.isKeyDown("d")) {
            turret.turn(2);
        }  
        if (Greenfoot.isKeyDown("space")) 
        {
            wishesToFire = true;
        }
    }
    
    public void processFiring() {
        if (curFireCount >= FIRING_DELAY) {
            curFireCount = 0;
            if (wishesToFire) 
            {
                wishesToFire = false;
                int[] bulletStart = trig.getOffsetFrom(turret.getX(),turret.getY(),turret.getRotation(),45);
                this.getWorld().addObject(new Bullet(turret.getRotation(),AITank.class, this),bulletStart[0],bulletStart[1]);
            }                
        }
        curFireCount++;
    }
    
    /**
     * called when the tank is added to the world, adds a turret
     */
    public void addedToWorld(World world) 
    {     
        world.addObject(turret,this.getX(),this.getY());       
    } 
    
    /**
     * destroy this tank & remove its turret
     */
    public void destroy() 
    {
        try 
        {
            this.getWorld().removeObject(turret); //remove the turret associated with me
            //NOTE: We do not use turret.destroy(); here as that'd destroy this object too.
        } catch (IllegalStateException e) 
        {
            System.out.println("Attempted to remove non existing turret");
        }
        TankWorld curWorld = (TankWorld)this.getWorld(); //find the current tankWorld
        curWorld.killPlayer(); //flag me as removed in the tankWorld
        super.destroy(); //remove me from world
    } 
}
