import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.*;
import java.util.Scanner.*;
import java.util.regex.*;
/**
 * Write a description of class TankWorld here.
 * 
 * @author me :D 
 * @version 1
 */
public class TankWorld  extends World
{
    public static final int CRATER_LIFE = 500;
    private SpriteMsg currentAchievement;
    private int currentWave = 1;
    private static final int MAX_WAVES = 15;
    private int currentEnemyTanks;
    private boolean playerAlive = true;
    private PlayerTank player;

    /**
     * Constructor for objects of class TankWorld.
     * 
     */
    public TankWorld()
    {    
        
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(640, 400, 1); 
        player = new PlayerTank();
        this.addObject(player,Greenfoot.getRandomNumber(this.getWidth()),Greenfoot.getRandomNumber(this.getHeight()));
        currentAchievement = new SpriteMsg("Achievement1.png",300);
        this.addObject(currentAchievement,this.getWidth()-200,this.getHeight()-20);
        this.setPaintOrder(Vehicle.class,SpriteMsg.class);
    }
    /**
     * act- called every frame
     */
    public void act() 
    {
        processAI();
    }
    /**
     * return the X pos of the player, if alive
     * if the player is dead returns the middle of the map
     */
    public int getPlayerX() 
    {
        if (playerAlive) {
            return player.getX();
        } else {
            return this.getWidth() / 2;
        }
        
    }
    
    /**
     * return the Y pos of the player, if alive
     * if the player is dead returns the middle of the map
     */
    public int getPlayerY() 
    {
        if (playerAlive) {
            return player.getY();            
        } else {
            return this.getHeight() / 2;
        }
        
    }
    /**
     * remove an enemy tank
     */
    public void removeAITank() 
    {
        if (currentWave == 1) 
        {
            currentAchievement = new SpriteMsg("Achievement2.png",300);
            this.addObject(currentAchievement,this.getWidth()-200,this.getHeight()-20);
        }
        currentEnemyTanks--;
        if (currentEnemyTanks < 0) {
            currentEnemyTanks = 0;
        }
    }
    /**
     * decide whether to add more AI tanks to the world
     */
    public void processAI() 
    {
        if (currentEnemyTanks == 0 && playerAlive) 
        {
            if (currentWave == 2) {
                currentAchievement = new SpriteMsg("Achievement3.png",300);
                this.addObject(currentAchievement,this.getWidth()-200,this.getHeight()-20);
            }
            for (int i = 1; i <=currentWave; i++) {
                this.addObject(new AITank(),Greenfoot.getRandomNumber(this.getWidth()),Greenfoot.getRandomNumber(this.getHeight()));
                currentEnemyTanks++;                       
            }
            if (currentWave < MAX_WAVES) {
                currentWave++;
            }
        }

    }
    public void killPlayer()
    {
        player = null;
        playerAlive = false;
        this.addObject(new SpriteMsg("GameOver.png",0),this.getWidth()/2,this.getHeight()/2);
    }
    public boolean isPlayerAlive() {
        return playerAlive;
    }
}
