import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Vehicle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Vehicle  extends Actor
{
    /**
     * Act - do whatever the Vehicle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }
    
    /**
     * move the vehicle with the specified speed. minus numbers go backwards.
     */
    public void move(int spd) 
    {
        double angle = Math.toRadians(getRotation());
        double x = Math.round(getX() + Math.cos(angle) * spd);
        double y = Math.round(getY() + Math.sin(angle) * spd);       
        setLocation((int)x, (int)y);    
    }
    
    /**
     * turn the vehicle by the specified angle
     */
    public void turn(int angle)
    {
        if (angle > 0) {                  
            if (getRotation() > 360) {
                setRotation(0);
            }  
            setRotation(getRotation()+angle); 
        } else {        
            if (getRotation() < 1) {
                setRotation(360);
            }  
            setRotation(getRotation()+angle);   
        }
    }
    /**
     * destroy the vehicle
     */
    public void destroy() 
    {
        try {
            TankWorld curWorld = (TankWorld)this.getWorld();
            curWorld.addObject(new SpriteMsg("Crater_Big.png",curWorld.CRATER_LIFE),this.getX(),this.getY());
            curWorld.removeObject(this);
        } catch (IllegalStateException e)
        {
            System.out.println("Caught IllegalState destroying vehicle");
        }
    }
    public boolean atWorldEdge() 
    {
        if (this.getWorld() != null) {
            if (this.getX() >= this.getWorld().getWidth() - 1 || this.getX() <= 0) 
            {
                return true;
            }
            if (this.getY() >= this.getWorld().getHeight() - 1 || this.getY() <= 0) 
            {
                return true;
            }        
            return false;
        }
        return false;
    }
}
